- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# MMaterialArray Class Reference

# OpenMayaUI - API module for user interface

Search for all occurrences

## Detailed Description

Array of pointers of MMaterial data type.

This class implements an array of MMaterial. Common convenience functions are available, and the implementation is compatible with the internal Maya implementation so that it can be passed efficiently between plugins and internal maya data structures.

`#include <MMaterialArray.h>`

List of all members.

## Public Member Functions
| MMaterialArray ()
| Default constructor.
| MMaterialArray (const MMaterialArray &other)
| Copy Constructor.
| ~MMaterialArray ()
| The class destructor.
const MMaterial | operator[] (unsigned index) const
| Returns the value of the element at the given index.
MMaterialArray & | operator= (const MMaterialArray &other)
| Assignment operator copies all of the elements of the other array into this one.
MStatus | set (const MMaterial &element, unsigned index)
| Sets the value of the indicated element to the indicated MMaterial value.
MStatus | setLength (unsigned length)
| Set the length of the array.
unsigned | length () const
| Returns the number of elements in the instance.
MStatus | remove (unsigned index)
| Remove the array element at the given index.
MStatus | insert (const MMaterial &element, unsigned index)
| Inserts a new value into the array at the given index.
MStatus | append (const MMaterial &element)
| Adds a new element to the end of the array.
MStatus | copy (const MMaterialArray &source)
| Copy the contents of the source array to this array.
MStatus | clear ()
| Clear the contents of the array.
void | setSizeIncrement (unsigned newIncrement)
| Set the size by which the array will be expanded whenever expansion is necessary.
unsigned | sizeIncrement () const
| Return the size by which the array will be expanded whenever expansion is necessary.
MMaterial | operator[] (unsigned index)
| Returns the value of the element at the given index.
## Static Public Member Functions
static const char * | className ()
| NO SCRIPT SUPPORT.

## Constructor & Destructor Documentation

MMaterialArray | ( |  | ) |

Default constructor.

The instance is set to contain no elements.

MMaterialArray | ( | const MMaterialArray & | other | ) |

Copy Constructor.

Parameters:

  [in] | other | the array with which to initialize this instance

## Member Function Documentation

const MMaterial operator[] | ( | unsigned | index | ) | const

Returns the value of the element at the given index.

No range checking is done - valid indices are 0 to length()-1.

Parameters:

  [in] | index | the index of the element whose value is to be returned

Returns:
  The value of the indicated element.

MMaterialArray & operator= | ( | const MMaterialArray & | other | ) |

Assignment operator copies all of the elements of the other array into this one.

If the other array was returned as a reference to internal data then this array will also become a reference rather than doing a full copy.

Parameters:

  [in] | other | the array being copied

Returns:
  A reference to this array

MStatus set | ( | const MMaterial & | element,
|  | unsigned | index
| ) |  |

Search for all occurrences

Sets the value of the indicated element to the indicated MMaterial value.

NOTE: This method does not grow the array if the index is out of bounds. Only a valid index should be used.

Parameters:

  [in] | element | the new value for the indicated element
  [in] | index | the index of the element that is to be set to the the new value

Returns:
  MS::kSuccess if the value was set successfully and MS::kFailure otherwise

MStatus setLength | ( | unsigned | length | ) |

Search for all occurrences

Set the length of the array.

This will grow and shrink the array as desired. Elements that are grown have uninitialized values, while those which are shrunk will lose the data contained in the deleted elements (ie. it will release the memory).

Parameters:

  [in] | length | the new size of the array

unsigned length | ( |  | ) | const

Search for all occurrences

Returns the number of elements in the instance.

Returns:
  The number of elements in the instance

MStatus remove | ( | unsigned | index | ) |

Search for all occurrences

Remove the array element at the given index.

All array elements following the removed element are shifted toward the first element.

Parameters:

  [in] | index | index of the element to be removed

Returns:
  MS::kSuccess if the remove was successful and MS::kFailure otherwise

MStatus insert | ( | const MMaterial & | element,
|  | unsigned | index
| ) |  |

Search for all occurrences

Inserts a new value into the array at the given index.

The initial element at that index, and all following elements, are shifted towards the last. If the array cannot be expanded in size by 1 element, then the insert will fail and the existing array will remain unchanged.

Parameters:

  [in] | element | the new value to insert into the array
  [in] | index | the index of the element to set to the the new value

Returns:
  true if the insert was successful and false otherwise

MStatus append | ( | const MMaterial & | element | ) |

Search for all occurrences

Adds a new element to the end of the array.

If the array cannot be expanded in size by 1 element, then the append will fail and the existing array will remain unchanged.

Parameters:

  [in] | element | the value for the new last element

Returns:
  MS::kSuccess if the append was successful and MS::kFailure otherwise

MStatus copy | ( | const MMaterialArray & | source | ) |

Search for all occurrences

Copy the contents of the source array to this array.

Parameters:

  [in] | source | array to copy from

Returns:
  MS::kSuccess if the copy was successful and MS::kFailure otherwise

MStatus clear | ( |  | ) |

Search for all occurrences

Clear the contents of the array.

After this operation the length method will return 0. This does not change the amount of memory allocated to the array, only the number of valid elements in it.

- MS::kSuccess if the operation is successful and MS::kFailure otherwise

void setSizeIncrement | ( | unsigned | newIncrement | ) |

Search for all occurrences

Set the size by which the array will be expanded whenever expansion is necessary.

Parameters:

  [in] | newIncrement | the new increment

unsigned sizeIncrement | ( |  | ) | const

Search for all occurrences

Return the size by which the array will be expanded whenever expansion is necessary.

Returns:
  The size increment.

MMaterial operator[] | ( | unsigned | index | ) |

Returns the value of the element at the given index.

No range checking is done - valid indices are 0 to length()-1.

Parameters:

  [in] | index | the index of the element whose value is to be returned

Returns:
  The value of the indicated element.

const char * className | ( |  | ) | `[static]`

Search for all occurrences

NO SCRIPT SUPPORT.

Returns the name of this class.

Returns:
  The name of this class.

MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray
MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray MMaterialArray